// Time-stamp: "09.07.09 11:09 lcd-routines.h klaus?wachtler.de"
//
// Ansteuerung eines HD44780 kompatiblen LCD im 4-Bit-Interfacemodus
// [1] http://www.mikrocontroller.net/articles/AVR-GCC-Tutorial
// [2] http://www.mikrocontroller.net/topic/88543#751982

#ifndef __lcd_routines_h__
#define __lcd_routines_h__

#ifdef __cplusplus
extern "C"
{
#endif /* ifdef __cplusplus */

// Pinbelegung fr das LCD, an verwendete Pins anpassen

#define LCD_PORT_4    PORTC
#define LCD_DDR_4     DDRC
#define LCD_D4        PC0

#define LCD_PORT_5    PORTC
#define LCD_DDR_5     DDRC
#define LCD_D5        PC1

#define LCD_PORT_6    PORTC
#define LCD_DDR_6     DDRC
#define LCD_D6        PC2

#define LCD_PORT_7    PORTC
#define LCD_DDR_7     DDRC
#define LCD_D7        PC3

#define LCD_RS_PORT   PORTC
#define LCD_RS_DDR    DDRC
#define LCD_RS        PC4

#define LCD_EN1_PORT  PORTC
#define LCD_EN1_DDR   DDRC
#define LCD_EN1       PC5



void lcd_string( const char *data );
void lcd_init( void );
void lcd_home( void );
void lcd_clear( void );
void lcd_set_cursor( uint8_t x, uint8_t y );


#ifdef __cplusplus
} /* extern "C" */
#endif /* ifdef __cplusplus */


#endif /* ifndef __lcd_routines_h__ */
