// Time-stamp: "09.08.11 06:44 testfixpoint_linux.cpp klaus?wachtler.de"
//
// Linux:
// g++ -Wall -Wextra -DTESTFIXPOINT -I. testfixpoint_linux.cpp -o testfixpoint_linux

#include <iostream>

#include <fixpoint.h>
#include <iomanip>




#define DEMOOP( INDENT, OP, SCALE )                                                                               \
{                                                                                                                 \
      cf = af OP bf;                                                                                              \
      c2 = a2 OP b2;                                                                                              \
      if( cf!=(double)c2 )                                                                                        \
      {                                                                                                           \
        std::cout << INDENT << "  - WARNING: a "#OP" b = c as float != fixed:" << std::endl;                      \
        std::cout << INDENT << "    a     =" << ia << "*" << pow( 2, -SCALE ) << "  (" << a2 << ")" << std::endl; \
        std::cout << INDENT << "    b     =" << ib << "*" << pow( 2, -SCALE ) << "  (" << b2 << ")" << std::endl; \
        std::cout << INDENT << "    float = " << cf << std::endl;                                                 \
        std::cout << INDENT << "    fixed = " << c2 << std::endl;                                                 \
      }                                                                                                           \
}

#define DEMOBASICOPERATIONS( BASETYPE,SCALE,DIVISOR,STARTA,ENDA,STARTB,ENDB,ROUNDTONEAREST,INDENT, SUPPRESSNEGATIVE, ia, ib )  \
{                                                                                                                              \
      double  af = double( ia )*pow( 2, -SCALE ), bf = double( ib )*pow( 2, -SCALE ), cf;                                      \
      Anyware::fixpoint< BASETYPE, BASETYPE, SCALE, ROUNDTONEAREST >  a2( (BASETYPE)ia, DIVISOR ), b2( ib, DIVISOR ), c2;      \
      if( af!=(double)a2 )                                                                                                     \
      {                                                                                                                        \
        std::cout << INDENT << "WARNING: a float != a fixed:" << std::endl;                                                    \
        std::cout << INDENT << "  float = " << af << std::endl;                                                                \
        std::cout << INDENT << "  fixed = " << a2 << std::endl;                                                                \
      }                                                                                                                        \
      if( bf!=(double)b2 )                                                                                                     \
      {                                                                                                                        \
        std::cout << INDENT << "WARNING: b float != b fixed:" << std::endl;                                                    \
        std::cout << INDENT << "  float = " << bf << std::endl;                                                                \
        std::cout << INDENT << "  fixed = " << b2 << std::endl;                                                                \
      }                                                                                                                        \
                                                                                                                               \
      DEMOOP( INDENT"   ", +, SCALE );                                                                                         \
      if( (!SUPPRESSNEGATIVE) || (ib<=ia) )                                                                                    \
      {                                                                                                                        \
        DEMOOP( INDENT"   ", -, SCALE );                                                                                       \
      }                                                                                                                        \
      DEMOOP( INDENT"   ", *, SCALE );                                                                                         \
      if( ib!=0 )                                                                                                              \
      {                                                                                                                        \
        DEMOOP( INDENT"   ", /, SCALE );                                                                                       \
      }                                                                                                                        \
}

#define DEMORANGE( BASETYPE, SCALE, DIVISOR, STARTA, ENDA, STARTB, ENDB, ROUNDTONEAREST, INDENT, SUPPRESSNEGATIVE )            \
{                                                                                                                              \
  std::cout << "\n" INDENT "fixpoint< TBASE=" #BASETYPE "TTEMP=" #BASETYPE ", SCALEBINARY=" << SCALE                           \
            << ", ROUNDTONEAREST=" << ROUNDTONEAREST << " >"                                                                   \
            << " Dividend=" << STARTA << "..." << ENDA                                                                         \
            << " und Divisor=" << STARTB << "..." << ENDB                                                                      \
            << " DIVISOR=" << DIVISOR                                                                                          \
            << std::endl;                                                                                                      \
  for( int ia=STARTA; ia<=ENDA; ++ia )                                                                                         \
  {                                                                                                                            \
    for( int ib=STARTB; ib<=ENDB; ++ib )                                                                                       \
    {                                                                                                                          \
      DEMOBASICOPERATIONS( BASETYPE,SCALE,DIVISOR,STARTA,ENDA,STARTB,ENDB,ROUNDTONEAREST,                                      \
                           INDENT"    ", SUPPRESSNEGATIVE, ia, ib );                                                           \
    }                                                                                                                          \
  }                                                                                                                            \
}

#define DEMOBASETYPE( BASETYPE, SCALE, DIVISOR, VON, BIS, SUPPRESSNEGATIVE )                         \
{                                                                                                    \
  std::cout << "\n    base type: " << #BASETYPE << std::endl;                                        \
  DEMORANGE( BASETYPE, SCALE, DIVISOR, VON, BIS, VON, BIS, false, "        ", SUPPRESSNEGATIVE );    \
  DEMORANGE( BASETYPE, SCALE, DIVISOR, VON, BIS, VON, BIS, true, "        ", SUPPRESSNEGATIVE );     \
}

#include <math.h>


// Diese Berechnung ist identisch mit der in AVR_LCD44780_fixpoint.cpp
void demoloop()
{
  typedef double                                        test_t;   typedef double   const_t;
  //typedef uint8_t                                       test_t;   typedef uint8_t  const_t;
  //typedef uint16_t                                      test_t;   typedef uint16_t const_t;
  //typedef uint32_t                                      test_t;   typedef uint32_t const_t;
  //typedef uint64_t                                      test_t;   typedef uint64_t const_t;
  //typedef Anyware::fixpoint< uint8_t, uint8_t, 1 >      test_t;   typedef uint8_t  const_t;
  //typedef Anyware::fixpoint< uint8_t, uint16_t, 1 >     test_t;   typedef uint8_t  const_t;
  //typedef Anyware::fixpoint< uint16_t, uint16_t, 1 >    test_t;   typedef uint16_t const_t;
  //typedef Anyware::fixpoint< uint16_t, uint32_t, 1 >    test_t;   typedef uint16_t const_t;
  //typedef Anyware::fixpoint< uint32_t, uint32_t, 1 >    test_t;   typedef uint32_t const_t;
  //typedef Anyware::fixpoint< uint32_t, uint64_t, 1 >    test_t;   typedef uint32_t const_t;
  //typedef Anyware::fixpoint< uint64_t, uint64_t, 1 >    test_t;   typedef uint64_t const_t;

  clock_t     start, ende;
  start = clock();

  test_t    a, b, c;

  const uint64_t     nLoop2 = 200000000;

  for( size_t i=0; i<nLoop2; ++i )
  {
    size_t       i;
    const size_t nLoop = 10;
    a = (const_t)3;
    b = (const_t)1;
    c = (const_t)1;

    for( i=0; i<nLoop; ++i )
    {
      if( (i%4)<2 )
      {
        b *= (const_t)2;
        a += b;
        c += a*b;
      }
      else
      {
        c -= a*b;
        a -= b;
        b /= (const_t)2;
      }
    }
  }

  ende = clock();

  std::cout << "" << (double)( ende - start )/CLOCKS_PER_SEC << " sec" << std::endl;

  std::cout << std::endl;
  std::cout << "a = " << (double)a << std::endl;
  std::cout << "b = " << (double)b << std::endl;
  std::cout << "c = " << (double)c << std::endl;
}


int main( int nargs, char **args )
{
  //DEMOBASETYPE( uint32_t, 2, 4,   0, 10, true );
  //DEMOBASETYPE(  int32_t, 2, 4, -10, 10, true );
  //DEMOBASETYPE( uint16_t, 2, 4,   0, 10, true );
  //DEMOBASETYPE(  int16_t, 2, 4, -10, 10, true );

  //Anyware::fixpoint< int32_t, int32_t, 3, true >  a( -5, 8 );
  //std::cout << "a=" << a << std::endl;
  //++a;
  //std::cout << "a=" << a << std::endl;

  //{
  //  for( int ia=-6; ia<=6; ++ia )
  //  {
  //    for( int ib=-2; ib<=2; ++ib )
  //    {
  //      if( ib!=0 )
  //      {
  //        Anyware::fixpoint< int32_t, int32_t, 2, true >    a( ia, 4 ), b( ib, 4 );
  //        std::cout << "fixpoint: " << double(a) << " % " << double(b) << " = " << (a%b) << std::endl;
  //        std::cout << "float:    " << ia*0.25 << " % " << ib*0.25 << " = " << fmod( ia*0.25, ib*0.25) << std::endl;
  //        std::cout << std::endl;
  //      }
  //    }
  //  }
  //}


  //{
  //  double   a = 7.7, b = 4.4;
  //  std::cout << "7.7%4.4=" << fmod( a, b ) << std::endl;
  //}


  //Anyware::fixpoint< int32_t, int32_t, 3, true >   a;
  //a = 15; // oder 1 oder Anyware::fixpoint< int32_t, 3, true >( 3, 2 )
  //std::cout << "a=" << a << std::endl;
  //Anyware::fixpoint< int32_t, int32_t, 3, true >  b;
  //b = 150;
  //std::cout << "b=" << b << std::endl;
  //b /= a;
  //std::cout << "b=" << std::setprecision(4) << std::showpoint << b << std::endl;
  //
  //std::cout << "als int:" << (int32_t)b << std::endl;


  demoloop();


  //Anyware::fixpoint< int32_t, int32_t, 2, true >  a( 25, 4 ), b( 10, 4 );
  //Anyware::fixpoint< int32_t, int32_t, 2, true >  c;
  //
  //c = a/b;
  //std::cout << "a=" << a << "\nb=" << b << "\na/b=" << c << std::endl << std::endl;
  //
  //c = a%b;
  //std::cout << "a=" << a << "\nb=" << b << "\na%b=" << c << std::endl << std::endl;
  //
  //std::cout << "fmod(" << double(a) << "," << double(b) << ") meint: " << fmod( double(a), double(b) ) << std::endl;
}
